## bpfcc 0.30.0+ds

=== src/python/CMakeLists.txt ===
# Copyright (c) PLUMgrid, Inc.
# Licensed under the Apache License, Version 2.0 (the "License")

if(NOT PYTHON_CMD)
  set(PYTHON_CMD "python3")
endif()

if(EXISTS "/etc/debian_version" AND NOT PY_SKIP_DEB_LAYOUT)
  set(PYTHON_FLAGS "${PYTHON_FLAGS} --install-layout deb")
endif()

file(GLOB_RECURSE PYTHON_SOURCES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/*.py)
file(GLOB_RECURSE PYTHON_INCLUDES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/*.py.in)

foreach(PY_CMD ${PYTHON_CMD})
  string(REPLACE "/" "-" PY_CMD_ESCAPED ${PY_CMD})
  set(PY_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/bcc-${PY_CMD_ESCAPED})

  foreach(PY_SRC ${PYTHON_SOURCES})
    configure_file(${PY_SRC} ${PY_DIRECTORY}/${PY_SRC} COPYONLY)
  endforeach()

  foreach(PY_INC ${PYTHON_INCLUDES})
    string(REPLACE ".py.in" ".py" PY_INC_REPLACED ${PY_INC})
    configure_file(${PY_INC} ${PY_DIRECTORY}/${PY_INC_REPLACED} @ONLY)
  endforeach()

  set(PIP_INSTALLABLE "${PY_DIRECTORY}/dist/bcc-${REVISION}.tar.gz")
  add_custom_command(
    OUTPUT ${PIP_INSTALLABLE}
    COMMAND ${PY_CMD} setup.py sdist
    WORKING_DIRECTORY ${PY_DIRECTORY}
    DEPENDS ${PYTHON_SOURCES} ${PYTHON_INCLUDES}
    COMMENT "Building sdist for ${PY_CMD}"
  )
  add_custom_target(bcc_py_${PY_CMD_ESCAPED} ALL DEPENDS ${PIP_INSTALLABLE})

  if(NOT PYTHON_PREFIX)
     set(PYTHON_PREFIX ${CMAKE_INSTALL_PREFIX})
  endif()

  install(
    CODE "
      execute_process(
        COMMAND ${PY_CMD} setup.py install -f ${PYTHON_FLAGS} --prefix=${PYTHON_PREFIX} --record ${CMAKE_BINARY_DIR}/install_manifest_python_bcc.txt
        WORKING_DIRECTORY ${PY_DIRECTORY})"
    COMPONENT python)
endforeach()

=== examples/usdt_sample/usdt_sample_app1/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(usdt_sample_app1)

add_executable( ${PROJECT_NAME}
    ${CMAKE_CURRENT_SOURCE_DIR}/main.cpp
)

target_link_libraries( ${PROJECT_NAME}
    usdt_sample_lib1
    pthread
)

=== examples/usdt_sample/usdt_sample_lib1/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(usdt_sample_lib1)

# Define variables.
set(USDT_SAMPLE_LIB1_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include CACHE STRING "USDT_SAMPLE_LIB1_INCLUDE_DIR" FORCE)
set(USDT_SAMPLE_LIB1_SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src CACHE STRING "USDT_SAMPLE_LIB1_SRC_DIR" FORCE)
set(USDT_SAMPLE_LIB1_LINK_DIR ${CMAKE_CURRENT_BINARY_DIR} CACHE STRING "USDT_SAMPLE_LIB1_LINK_DIR" FORCE)
set(USDT_SAMPLE_LIB1_LIB ${PROJECT_NAME} CACHE STRING "USDT_SAMPLE_LIB1_LIB" FORCE)
set(USDT_SAMPLE_LIB1_GENERATED ${CMAKE_CURRENT_BINARY_DIR}/generated)
set(USDT_SAMPLE_SDT_HEADER ${USDT_SAMPLE_LIB1_SRC_DIR}/lib1_sdt.h)
set(USDT_SAMPLE_SDT_OBJECT ${USDT_SAMPLE_LIB1_GENERATED}/lib1_sdt.o)
set(USDT_SAMPLE_SDT_PROBES ${USDT_SAMPLE_LIB1_SRC_DIR}/lib1_sdt.d)

add_library( ${PROJECT_NAME} SHARED
    ${USDT_SAMPLE_LIB1_SRC_DIR}/lib1.cpp
)

target_include_directories( ${PROJECT_NAME}
    PRIVATE
        # For folly StaticTracepoint.h:
        ${CMAKE_CURRENT_SOURCE_DIR}/../../../tests/python/include
    PUBLIC
        ${USDT_SAMPLE_LIB1_INCLUDE_DIR}
)

target_link_libraries( ${PROJECT_NAME}
    ${USDT_SAMPLE_SDT_OBJECT}
)

## Start - N.B. Following section is relevant for when using systemtap-sdt-devel to define the probes.

# Create usdt header file.
add_custom_target( ${PROJECT_NAME}_HDR_CLEAN
   COMMAND rm -f ${USDT_SAMPLE_SDT_HEADER}
   COMMENT "Remove generated header"
)
add_custom_target( ${PROJECT_NAME}_HDR
   COMMAND dtrace -h -s ${USDT_SAMPLE_SDT_PROBES} -o ${USDT_SAMPLE_SDT_HEADER}
   COMMENT "Create usdt probes header file"
)
add_dependencies(${PROJECT_NAME}_HDR ${PROJECT_NAME}_HDR_CLEAN)

# Create usdt object file.
add_custom_target( ${PROJECT_NAME}_CLEAN
   COMMAND rm -rf ${USDT_SAMPLE_LIB1_GENERATED} && mkdir -p ${USDT_SAMPLE_LIB1_GENERATED}
   COMMENT "Recreate usdt probes generated folder"
)
add_custom_target( ${PROJECT_NAME}_OBJ
   COMMAND dtrace -G -s ${USDT_SAMPLE_SDT_PROBES} -o ${USDT_SAMPLE_SDT_OBJECT}
   COMMENT "Create usdt probes object file"
)
add_dependencies(${PROJECT_NAME}_OBJ ${PROJECT_NAME}_CLEAN)

add_dependencies(${PROJECT_NAME} ${PROJECT_NAME}_HDR ${PROJECT_NAME}_OBJ)

## End

=== debian/changelog ===
bpfcc (0.30.0+ds-1ubuntu5) plucky; urgency=medium

  * SRU: #2083480: No-change rebuild to add support for Python 3.13.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 13 Nov 2024 09:57:29 +0100

bpfcc (0.30.0+ds-1ubuntu4) oracular; urgency=medium

  * control: Build with llvm-18, FTBFS with 19.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 18 Sep 2024 15:59:54 +0300

bpfcc (0.30.0+ds-1ubuntu3) oracular; urgency=medium

  * d/control: enable ppc64el for bpfcc-introspection (LP: #2074621).

 -- Vladimir Petko <vladimir.petko@canonical.com>  Tue, 30 Jul 2024 08:16:00 +1200

bpfcc (0.30.0+ds-1ubuntu2) oracular; urgency=medium

  * d/control: enable ppc64el architecture (LP: #2074121).

 -- Vladimir Petko <vladimir.petko@canonical.com>  Fri, 26 Jul 2024 08:34:48 +1200

bpfcc (0.30.0+ds-1ubuntu1) oracular; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - d/t/control: Run testsuite as autopkgtest (LP: #2052813)
    - Depend on linux-tools-generic instead of bpftool (See LP: #1981089)
    - Export bpftool binary to avoid system trying to use the chroot kernel
      (uname -r command)
    - Add back riscv64 to tool_skip_arch, fixing FTBFS
  * Grab changes from Mate Kukri <mate.kukri@canonical.com>
    - Disable test incompatible with the 6.10 kernel

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 19 Jul 2024 08:59:39 +0200

bpfcc (0.30.0+ds-1) unstable; urgency=medium

  * [383b111] New upstream version 0.30.0+ds
  * [698ac74] Refresh patch 0001
  * [d115482] Refresh patch 2003-libbpf-tools-debian.patch

 -- Vasudev Kamath <vasudev@debian.org>  Fri, 19 Jul 2024 10:37:16 +0530

bpfcc (0.29.1+ds-1.2ubuntu2) oracular; urgency=medium

  * Add back riscv64 to tool_skip_arch, fixing FTBFS

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 18 Jul 2024 12:21:57 +0200

bpfcc (0.29.1+ds-1.2ubuntu1) oracular; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/t/control: Run testsuite as autopkgtest (LP:2052813)
    - d/p/a55b5a0c920f3839fbb29b0e8837726f5fe49c72.patch:
      - cherry-pick upstream build fix for kernel 6.6+
    - Depend on linux-tools-generic instead of bpftool (See LP: #1981089)
    - Export bpftool binary to avoid system trying to use the chroot kernel
      (uname -r command)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 16 Jul 2024 21:35:12 +0200

bpfcc (0.29.1+ds-1.2) unstable; urgency=medium

  * Non-maintainer upload.

  [ zhangdandan <zhangdandan@loongson.cn> ]
  * Add support for loongarch64 (Closes: #1072569)

  [ Bo YU <tsu.yubo@gmail.com> ]
  * Add support for riscv64 (Closes: #1036051)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 16 Jul 2024 21:31:52 +0200

bpfcc (0.29.1+ds-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * [46b1ef4] Drop ppc64el from supported architectures (Closes: #1070768)

 -- Luca Boccassi <bluca@debian.org>  Sat, 11 May 2024 11:46:38 +0100

=== debian/control ===
Source: bpfcc
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Ritesh Raj Sarraf <rrs@debian.org>
Uploaders: Vasudev Kamath <vasudev@debian.org>
Section: misc
Priority: optional
Standards-Version: 4.6.2
Build-Depends: arping,
 bison,
 clang-format,
 cmake,
 debhelper-compat (= 13),
 dh-python,
 pkg-kde-tools,
 ethtool,
 flex,
 inetutils-ping | iputils-ping,
 iperf,
 libbpf-dev (>= 1:0.4.0~),
 libclang-18-dev,
 libclang-cpp18-dev,
 libedit-dev,
 libelf-dev,
 libfl-dev,
 libzip-dev,
 linux-libc-dev (>= 5.10~),
 llvm-18-dev,
 libluajit-5.1-dev [amd64 armel armhf i386 mips mipsel powerpc],
 luajit [amd64 armel armhf i386 mips mipsel powerpc],
 python3-netaddr,
 python3-pyroute2,
 python3-setuptools,
 zip,
 python3:any | python3-all:any | python3-dev:any | python3-all-dev:any | dh-sequence-python3,
 linux-tools-generic,
 clang
Homepage: https://github.com/iovisor/bcc
Vcs-Git: https://salsa.debian.org/debian/bpfcc.git
Vcs-Browser: https://salsa.debian.org/debian/bpfcc
Rules-Requires-Root: no

Package: libbpfcc
Architecture: amd64 arm64 loong64 ppc64 ppc64el s390x armhf riscv64
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: shared library for BPF Compiler Collection (BCC)
 BPF Compiler Collection (BCC) is a toolkit for creating efficient
 kernel tracing and manipulation programs
 .
 It makes use of extended BPF (Berkeley Package Filter) and provides tools
 for BPF based Linux IO analysis, networking, monitoring and more
 .
 This package provides the shared library for BPF Compiler Collection
 to control BPF programs from userspace.

Package: libbpfcc-dev
Architecture: amd64 arm64 loong64 ppc64 ppc64el s390x armhf riscv64
Section: libdevel
Depends: ${misc:Depends},
 libbpfcc (= ${binary:Version})
Multi-Arch: same
Description: shared library for BPF Compiler Collection (BCC)
 BPF Compiler Collection (BCC) is a toolkit for creating efficient
 kernel tracing and manipulation programs
 .
 It makes use of extended BPF (Berkeley Package Filter) and provides tools
 for BPF based Linux IO analysis, networking, monitoring and more
 .
 This package provides the development headers for BPF Compiler Collection

Package: python3-bpfcc
Architecture: all
Section: python
Depends: libbpfcc (>= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends}
Description: Python 3 wrappers for BPF Compiler Collection (BCC)
 BPF Compiler Collection (BCC) is a toolkit for creating efficient
 kernel tracing and manipulation programs
 .
 It makes use of extended BPF (Berkeley Package Filter) and provides tools
 for BPF based Linux IO analysis, networking, monitoring and more
 .
 This package provides the Python 3 bindings

Package: bpfcc-tools
Architecture: all
Depends: python3-bpfcc (>= ${binary:Version}),
         python3-netaddr,
         ${misc:Depends},
         ${python3:Depends}
Description: tools for BPF Compiler Collection (BCC)
 BPF Compiler Collection (BCC) is a toolkit for creating efficient
 kernel tracing and manipulation programs
 .
 It makes use of extended BPF (Berkeley Package Filter) and provides tools
 for BPF based Linux IO analysis, networking, monitoring and more
 .
 This package provides the command-line tools and examples

Package: libbpf-tools
Architecture: amd64 arm64
Depends: ${misc:Depends},
 ${shlibs:Depends}
Description: tools for BPF Compiler Collection based on libbpf (BTF and CO-RE)
 BPF Compiler Collection (BCC) is a toolkit for creating efficient
 kernel tracing and manipulation programs
 .
 It makes use of extended BPF (Berkeley Package Filter) and provides tools
 for BPF based Linux IO analysis, networking, monitoring and more
 .
 This package provides the tools from bpfcc-tools but written in a portable
 fashion using BTF and libbpf hence the installation footprint will be smaller
 compared to bpfcc-tools.
 .
 At this time this package contains subset of tools from bpfcc-tools

Package: bpfcc-introspection
Architecture: amd64 arm64 loong64 ppc64 ppc64el riscv64
Depends: ${misc:Depends},
 ${shlibs:Depends},
 libbpfcc (= ${binary:Version})
Description: tool to help introspect BPF programs
 BPF Compiler Collection (BCC) is a toolkit for creating efficient
 kernel tracing and manipulation programs
 .
 It makes use of extended BPF (Berkeley Package Filter) and provides tools
 for BPF based Linux IO analysis, networking, monitoring and more
 .
 This package provides tools to introspect BPF programs. Currently following
 programs are provided as part of this package.
 .
  - bps: Lists all BPF programs loaded into the kernel. `ps` for BPF programs
 .

Package: bpfcc-lua
Architecture: amd64
Depends: libbpfcc (>= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: Standalone tool to run BCC tracers written in Lua
 BPF Compiler Collection (BCC) is a toolkit for creating efficient
 kernel tracing and manipulation programs
 .
 It makes use of extended BPF (Berkeley Package Filter) and provides tools
 for BPF based Linux IO analysis, networking, monitoring and more
 .
 This package provides the Lua bindings

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk

# for building libbpf-tools on selective architecture
include /usr/share/dpkg/architecture.mk
libbpf_tool_skip_arch := armhf s390x ppc64 riscv64

export BPFTOOL=$(shell ls -1 /usr/lib/linux-tools-*/bpftool | tail -n 1)
# Disable tests as they require root to run
export DEB_BUILD_MAINT_OPTIONS=nocheck
export DEB_CPPFLAGS_MAINT_APPEND=-DCUSTOM_MACRO=true

DEB_DIR=$(abspath $(dir $(firstword $(MAKEFILE_LIST))))

# Remove the +ds suffix from the version passed to CMake
VERSION_UPSTREAM=$(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/+ds$$//')


%:
	dh $@ --buildsystem=cmake --with pkgkde_symbolshelper,python3

override_dh_auto_clean:
ifneq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(libbpf_tool_skip_arch)))
	make -C libbpf-tools V=1 clean
endif
	dh_auto_clean
	sed -i 's|lib=$$(dirname $$0)$$|lib=$$(dirname $$0)/lib|' $(CURDIR)/tools/*.sh

override_dh_auto_configure:
	sed -i "s/\/lib//" $(CURDIR)/tools/*.sh
	dh_auto_configure -- -DREVISION_LAST=$(VERSION_UPSTREAM) \
		-DREVISION=$(VERSION_UPSTREAM) \
		-DCMAKE_USE_LIBBPF_PACKAGE=on \
		-DLLVM_DEFINITIONS="-D_GNU_SOURCE -D__STDC_CONSTANT_MACROS -D__STDC_FORMAT_MACROS -D__STDC_LIMIT_MACROS" \
		-DPYTHON_CMD="python3" -DENABLE_LLVM_SHARED=on

override_dh_auto_install:
	dh_auto_install
ifneq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(libbpf_tool_skip_arch)))
	make -C libbpf-tools V=1 prefix=$(DEB_DIR)/tmp/libbpf-tools install
endif
	test -d $(CURDIR)/debian/tmp/usr/share/bcc/tools/doc && \
		mv $(CURDIR)/debian/tmp/usr/share/bcc/tools/doc/* \
			$(CURDIR)/debian/tmp/usr/share/bcc/doc/ && \
		rm -d $(CURDIR)/debian/tmp/usr/share/bcc/tools/doc


	for eachFile in $(CURDIR)/debian/tmp/usr/share/bcc/tools/* ; do \
			test -f  $$eachFile && mv $$eachFile $$eachFile-bpfcc ; \
	done

	# Don't rename the C file to different name and move it to
	# /usr/share/bpfcc-tools/
	mkdir -p $(CURDIR)/debian/bpfcc-tools/usr/share/bpfcc-tools/
	mv $(CURDIR)/debian/tmp/usr/share/bcc/tools/deadlock.c-bpfcc \
		$(CURDIR)/debian/bpfcc-tools/usr/share/bpfcc-tools/deadlock.c ; \
	mv $(CURDIR)/debian/tmp/usr/share/bcc/tools/netqtop.c-bpfcc \
		$(CURDIR)/debian/bpfcc-tools/usr/share/bpfcc-tools/netqtop.c ; \

	# Move the swapin_example file to usr/share/bcc/doc and remove -bpfcc its a
	# text file
	mv $(CURDIR)/debian/tmp/usr/share/bcc/tools/swapin-bpfcc \
		$(CURDIR)/debian/tmp/usr/share/bcc/doc/swapin.txt ; \
	chmod -x $(CURDIR)/debian/tmp/usr/share/bcc/doc/swapin.txt ; \

	for eachMan in $(CURDIR)/debian/tmp/usr/share/bcc/man/man8/* ; do \
			test -f $$eachMan && manPage=`basename $$eachMan | cut -d "." -f1`; \
			if [ $$manPage != "bps" ]; then \
				mv $$eachMan $(CURDIR)/debian/tmp/usr/share/bcc/man/man8/$$manPage-bpfcc.8 ; \
			else \
				mkdir -p $(CURDIR)/debian/tmp/usr/share/bcc/introspection/man/man8/ ; \
				mv $$eachMan $(CURDIR)/debian/tmp/usr/share/bcc/introspection/man/man8/ ;\
			fi \
	done

	#FIXME: I know this is ugly but for the time being doing it this way
	for eachMan in $(CURDIR)/debian/tmp/usr/share/bcc/man/man8/* ; do \
		test -f $$eachMan && manPage=`basename $$eachMan | cut -d "." -f1 | cut -d "-" -f1`; \
		if [ $$manPage = "ucalls" -o $$manPage = "uflow" -o $$manPage = "ugc" \
					-o $$manPage = "uobjnew" -o $$manPage = "ustat" -o $$manPage = "uthreads" ]; then \
				mv $$eachMan $(CURDIR)/debian/tmp/usr/share/bcc/man/man8/$$manPage.8 ; \
		fi \
	done


# Some binaries end up in wrong paths like /usr/sbin/lib/
# THis fixes those
	test -d $(CURDIR)/debian/tmp/usr/share/bcc/tools/lib/ && \
		mv $(CURDIR)/debian/tmp/usr/share/bcc/tools/lib/* \
			$(CURDIR)/debian/tmp/usr/share/bcc/tools/ && \
		rm -rf $(CURDIR)/debian/tmp/usr/share/bcc/tools/lib/

override_dh_python3:
	# See Debian Bug #926187
	dh_python3 --shebang=/usr/bin/python3

override_dh_installdocs:
	dh_installdocs -A debian/README.Debian

override_dh_auto_test:
ifeq (,$(findstring nocheck,$(DEB_BUILD_MAINT_OPTIONS)))
	dh_auto_test
endif

## bpfcc 0.31.0+ds

=== libbpf-tools/Makefile ===
# SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause)
OUTPUT := $(abspath .output)
CLANG ?= clang
LLVM_STRIP ?= llvm-strip
BPFTOOL_SRC := $(abspath ./bpftool/src)
BPFTOOL_OUTPUT ?= $(abspath $(OUTPUT)/bpftool)
BPFTOOL ?= $(BPFTOOL_OUTPUT)/bootstrap/bpftool
LIBBPF_SRC := $(abspath ../src/cc/libbpf/src)
LIBBPF_OBJ := $(abspath $(OUTPUT)/libbpf.a)
LIBBLAZESYM_SRC := $(abspath blazesym/target/release/libblazesym.a)
INCLUDES := -I$(OUTPUT) -I../src/cc/libbpf/include/uapi
CFLAGS := -g -O2 -Wall -Wmissing-field-initializers -Werror
BPFCFLAGS := -g -O2 -Wall
INSTALL ?= install
prefix ?= /usr/local
bindir := $(prefix)/bin
ARCH ?= $(shell uname -m | sed 's/x86_64/x86/' | sed 's/aarch64/arm64/' \
			 | sed 's/ppc64le/powerpc/' | sed 's/mips.*/mips/' \
			 | sed 's/riscv64/riscv/' | sed 's/loongarch.*/loongarch/' \
			 | sed 's/s390x/s390/')
BTFHUB_ARCHIVE ?= $(abspath btfhub-archive)
ifeq ($(ARCH),x86)
CARGO ?= $(shell which cargo)
ifeq ($(strip $(CARGO)),)
USE_BLAZESYM ?= 0
else
USE_BLAZESYM ?= 1
endif
endif

ifeq ($(wildcard $(ARCH)/),)
$(error Architecture $(ARCH) is not supported yet. Please open an issue)
endif

BZ_APPS = \
	futexctn \
	memleak \
	opensnoop \
	#

APPS = \
	bashreadline \
	bindsnoop \
	biolatency \
	biopattern \
	biosnoop \
	biostacks \
	biotop \
	bitesize \
	cachestat \
	capable \
	cpudist \
	cpufreq \
	drsnoop \
	execsnoop \
	exitsnoop \
	filelife \
	filetop \
	fsdist \
	fsslower \
	funclatency \
	gethostlatency \
	hardirqs \
	javagc \
	klockstat \
	ksnoop \
	llcstat \
	mdflush \
	mountsnoop \
	numamove \
	offcputime \
	oomkill \
	profile \
	readahead \
	runqlat \
	runqlen \
	runqslower \
	sigsnoop \
	slabratetop \
	softirqs \
	solisten \
	statsnoop \
	syncsnoop \
	syscount \
	tcptracer \
	tcpconnect \
	tcpconnlat \
	tcplife \
	tcppktlat \
	tcprtt \
	tcpstates \
	tcpsynbl \
	tcptop \
	vfsstat \
	wakeuptime \
	$(BZ_APPS) \
	#

# export variables that are used in Makefile.btfgen as well.
export OUTPUT BPFTOOL ARCH BTFHUB_ARCHIVE APPS

FSDIST_ALIASES = btrfsdist ext4dist nfsdist xfsdist f2fsdist bcachefsdist
FSSLOWER_ALIASES = btrfsslower ext4slower nfsslower xfsslower f2fsslower bcachefsslower
SIGSNOOP_ALIAS = killsnoop
APP_ALIASES = $(FSDIST_ALIASES) $(FSSLOWER_ALIASES) ${SIGSNOOP_ALIAS}

COMMON_OBJ = \
	$(OUTPUT)/trace_helpers.o \
	$(OUTPUT)/syscall_helpers.o \
	$(OUTPUT)/errno_helpers.o \
	$(OUTPUT)/map_helpers.o \
	$(OUTPUT)/uprobe_helpers.o \
	$(OUTPUT)/btf_helpers.o \
	$(OUTPUT)/compat.o \
	$(if $(ENABLE_MIN_CORE_BTFS),$(OUTPUT)/min_core_btf_tar.o) \
	#

ifeq ($(USE_BLAZESYM),1)
COMMON_OBJ += \
	$(OUTPUT)/libblazesym.a \
	$(OUTPUT)/blazesym.h \
	#
endif

define allow-override
  $(if $(or $(findstring environment,$(origin $(1))),\
            $(findstring command line,$(origin $(1)))),,\
    $(eval $(1) = $(2)))
endef

$(call allow-override,CC,$(CROSS_COMPILE)cc)
$(call allow-override,LD,$(CROSS_COMPILE)ld)

.PHONY: all
all: $(APPS) $(APP_ALIASES)

ifeq ($(V),1)
Q =
msg =
else
Q = @
msg = @printf '  %-8s %s%s\n' "$(1)" "$(notdir $(2))" "$(if $(3), $(3))";
MAKEFLAGS += --no-print-directory
endif

ifneq ($(EXTRA_CFLAGS),)
CFLAGS += $(EXTRA_CFLAGS)
endif
ifneq ($(EXTRA_LDFLAGS),)
LDFLAGS += $(EXTRA_LDFLAGS)
endif
ifeq ($(USE_BLAZESYM),1)
CFLAGS += -DUSE_BLAZESYM=1
endif

ifeq ($(USE_BLAZESYM),1)
LDFLAGS += $(OUTPUT)/libblazesym.a -lrt -lpthread -ldl
endif

.PHONY: clean
clean:
	$(call msg,CLEAN)
	$(Q)rm -rf $(OUTPUT) $(APPS) $(APP_ALIASES)

$(LIBBLAZESYM_SRC)::
	$(Q)cd blazesym && cargo build --release --features=cheader

$(OUTPUT)/libblazesym.a: $(LIBBLAZESYM_SRC) | $(OUTPUT)
	$(call msg,LIB,$@)
	$(Q)cp $(LIBBLAZESYM_SRC) $@

$(OUTPUT)/blazesym.h: $(LIBBLAZESYM_SRC) | $(OUTPUT)
	$(call msg,INC,$@)
	$(Q)cp blazesym/target/release/blazesym.h $@

$(OUTPUT) $(OUTPUT)/libbpf $(BPFTOOL_OUTPUT):
	$(call msg,MKDIR,$@)
	$(Q)mkdir -p $@

$(BPFTOOL): | $(BPFTOOL_OUTPUT)
	$(call msg,BPFTOOL,$@)
	$(Q)$(MAKE) ARCH= CROSS_COMPILE=  OUTPUT=$(BPFTOOL_OUTPUT)/ -C $(BPFTOOL_SRC) bootstrap

$(APPS): %: $(OUTPUT)/%.o $(COMMON_OBJ) $(LIBBPF_OBJ) | $(OUTPUT)
	$(call msg,BINARY,$@)
	$(Q)$(CC) $(CFLAGS) $^ $(LDFLAGS) -lelf -lz -o $@

ifeq ($(USE_BLAZESYM),1)
$(patsubst %,$(OUTPUT)/%.o,$(BZ_APPS)): $(OUTPUT)/blazesym.h
endif

$(patsubst %,$(OUTPUT)/%.o,$(APPS)): %.o: %.skel.h

$(OUTPUT)/%.o: %.c $(wildcard %.h) $(LIBBPF_OBJ) | $(OUTPUT)
	$(call msg,CC,$@)
	$(Q)$(CC) $(CFLAGS) $(INCLUDES) -c $(filter %.c,$^) -o $@

$(OUTPUT)/%.skel.h: $(OUTPUT)/%.bpf.o | $(OUTPUT) $(BPFTOOL)
	$(call msg,GEN-SKEL,$@)
	$(Q)$(BPFTOOL) gen skeleton $< > $@

$(OUTPUT)/%.bpf.o: %.bpf.c $(LIBBPF_OBJ) $(wildcard %.h) $(ARCH)/vmlinux.h | $(OUTPUT)
	$(call msg,BPF,$@)
	$(Q)$(CLANG) $(BPFCFLAGS) -target bpf -D__TARGET_ARCH_$(ARCH)	      \
		     -I$(ARCH)/ $(INCLUDES) -c $(filter %.c,$^) -o $@ &&      \
	$(LLVM_STRIP) -g $@

btfhub-archive: force
	$(call msg,GIT,$@)
	$(Q)[ -d "$(BTFHUB_ARCHIVE)" ] || git clone -q https://github.com/aquasecurity/btfhub-archive/ $(BTFHUB_ARCHIVE)
	$(Q)cd $(BTFHUB_ARCHIVE) && git pull

ifdef ENABLE_MIN_CORE_BTFS
$(OUTPUT)/min_core_btf_tar.o: $(patsubst %,$(OUTPUT)/%.bpf.o,$(APPS)) btfhub-archive | bpftool
	$(Q)$(MAKE) -f Makefile.btfgen
endif

# Build libbpf.a
$(LIBBPF_OBJ): $(wildcard $(LIBBPF_SRC)/*.[ch]) | $(OUTPUT)/libbpf
	$(call msg,LIB,$@)
	$(Q)$(MAKE) -C $(LIBBPF_SRC) BUILD_STATIC_ONLY=1		      \
		    OBJDIR=$(dir $@)libbpf DESTDIR=$(dir $@)		      \
		    INCLUDEDIR= LIBDIR= UAPIDIR=			      \
		    install

$(FSSLOWER_ALIASES): fsslower
	$(call msg,SYMLINK,$@)
	$(Q)ln -f -s $(APP_PREFIX)$^ $@

$(FSDIST_ALIASES): fsdist
	$(call msg,SYMLINK,$@)
	$(Q)ln -f -s $(APP_PREFIX)$^ $@

$(SIGSNOOP_ALIAS): sigsnoop
	$(call msg,SYMLINK,$@)
	$(Q)ln -f -s $(APP_PREFIX)$^ $@

install: $(APPS) $(APP_ALIASES)
	$(call msg, INSTALL libbpf-tools)
	$(Q)$(INSTALL) -m 0755 -d $(DESTDIR)$(bindir)
	$(Q)$(foreach app,$(APPS),$(INSTALL) $(app) $(DESTDIR)$(bindir)/$(APP_PREFIX)$(app);)
	$(Q)$(foreach alias,$(APP_ALIASES),cp -a $(alias) $(DESTDIR)$(bindir)/$(APP_PREFIX)$(alias);)

.PHONY: force
force:

# delete failed targets
.DELETE_ON_ERROR:
# keep intermediate (.skel.h, .bpf.o, etc) targets
.SECONDARY:

=== debian/changelog ===
bpfcc (0.31.0+ds-7ubuntu2) questing; urgency=medium

  * d/p/git-fix-llvm20.patch: cherry pick upstream fixes for llvm20
  * d/control, d/p/2003-libbpf-tools-debian.patch:
        - llvm19->20 which is the current version and the one in main

 -- Sebastien Bacher <seb128@ubuntu.com>  Fri, 13 Jun 2025 16:03:25 +0200

bpfcc (0.31.0+ds-7ubuntu1) questing; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - d/control: enable ppc64el architecture (LP 2074121).
    - d/control: include ppc64el in the arches to skip for lua
    - d/control, d/p/2003-libbpf-tools-debian.patch:
      - Build with llvm-19, FTBFS with 20.
    - d/t/control: Run testsuite as autopkgtest (LP 2052813)
    - d/rules: add back riscv64 to tool_skip_arch, fixing FTBFS
  * Removed delta, bpftool has its own package also in Ubuntu now:
    - Depend on linux-tools-generic instead of bpftool
    - Export bpftool binary to avoid system trying to use the chroot kernel
  * d/p/disable-werror-to-fix-build.patch:
    - disable Werror for now to workaround build issues on ppc64el
      reported upstream https://github.com/iovisor/bcc/pull/5331
      (the previous version didn't use Werror)

 -- Sebastien Bacher <seb128@ubuntu.com>  Thu, 12 Jun 2025 11:16:01 +0200

bpfcc (0.31.0+ds-7) unstable; urgency=medium

  * [08d414e] Remove the bpf.h header file in clean target
    (Closes: #1043620)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Fri, 28 Mar 2025 15:37:43 +0530

bpfcc (0.31.0+ds-6) unstable; urgency=medium

  * [ba6b4ba] Fix libbpf-tools name mangling conditionally

 -- Ritesh Raj Sarraf <rrs@debian.org>  Thu, 27 Mar 2025 20:55:41 +0530

bpfcc (0.31.0+ds-5) unstable; urgency=medium

  [ Vasudev Kamath ]
  * [be5961e] Add missing history

  [ Ritesh Raj Sarraf ]
  * [8de04cb] Install each binary with an origin suffix (Closes: #1076223)
  * [e0b4de2] Add a NEWS entry for the libbpf binary renames

 -- Ritesh Raj Sarraf <rrs@debian.org>  Mon, 17 Mar 2025 15:09:42 +0530

bpfcc (0.31.0+ds-4) unstable; urgency=medium

  * Upload to Debian Unstable

 -- Ritesh Raj Sarraf <rrs@debian.org>  Wed, 02 Oct 2024 19:27:45 +0530

bpfcc (0.31.0+ds-4~exp2) experimental; urgency=medium

  * [e12ef64] Add arch loong64 and ppc64 in LUA block list

 -- Ritesh Raj Sarraf <rrs@debian.org>  Mon, 30 Sep 2024 16:14:19 +0530

bpfcc (0.31.0+ds-4~exp1) experimental; urgency=medium

  * [03bf70b] Disable lua support for the riscv64 arch

 -- Ritesh Raj Sarraf <rrs@debian.org>  Fri, 27 Sep 2024 20:07:42 +0530

bpfcc (0.31.0+ds-3) unstable; urgency=medium

  * [efa82a5] Drop architectures loong64 ppc64 riscv64 for bpfcc-lua
  * [dadf8f8] Drop the list of architectures for luajit build dependency

 -- Ritesh Raj Sarraf <rrs@debian.org>  Fri, 20 Sep 2024 15:05:37 +0530

bpfcc (0.31.0+ds-2) unstable; urgency=medium

  * Upload to Debian Unstable
  * [7a00bb4] Mark binary package bpfcc-lua be inline with binary package
    libbpfcc
  * [77e0d92] Enable luajit for arm64 as well

 -- Ritesh Raj Sarraf <rrs@debian.org>  Thu, 19 Sep 2024 19:50:36 +0530

bpfcc (0.31.0+ds-1) experimental; urgency=medium

  * [0dae105] New upstream version 0.31.0+ds
  * [97f6a06] Refresh and forward-port patches

 -- Ritesh Raj Sarraf <rrs@debian.org>  Wed, 18 Sep 2024 17:24:58 +0530

bpfcc (0.26.0+ds-2~experimental2) experimental; urgency=medium

  * [0e31111] Set architectures to linux-any

 -- Ritesh Raj Sarraf <rrs@debian.org>  Thu, 16 Feb 2023 21:10:18 +0530

bpfcc (0.26.0+ds-2~experimental1) experimental; urgency=medium

  * [ab623bb] Enable all available architecture builds (Closes: #1030657)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Wed, 15 Feb 2023 13:41:17 +0530

=== debian/control ===
--- 
+++ 
@@ -17,22 +17,22 @@
  inetutils-ping | iputils-ping,
  iperf,
  libbpf-dev (>= 1:0.4.0~),
- libclang-18-dev,
- libclang-cpp18-dev,
+ libclang-20-dev,
+ libclang-cpp20-dev,
  libedit-dev,
  libelf-dev,
  libfl-dev,
  libzip-dev,
  linux-libc-dev (>= 5.10~),
- llvm-18-dev,
- libluajit-5.1-dev [amd64 armel armhf i386 mips mipsel powerpc],
- luajit [amd64 armel armhf i386 mips mipsel powerpc],
+ llvm-20-dev,
+ libluajit-5.1-dev [!riscv64 !loong64 !ppc64 !ppc64el],
+ luajit [!riscv64 !loong64 !ppc64 !ppc64el],
  python3-netaddr,
  python3-pyroute2,
  python3-setuptools,
  zip,
  python3:any | python3-all:any | python3-dev:any | python3-all-dev:any | dh-sequence-python3,
- linux-tools-generic,
+ bpftool,
  clang
 Homepage: https://github.com/iovisor/bcc
 Vcs-Git: https://salsa.debian.org/debian/bpfcc.git
@@ -134,7 +134,7 @@
  .
 
 Package: bpfcc-lua
-Architecture: amd64
+Architecture: amd64 arm64 s390x armhf
 Depends: libbpfcc (>= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends}

## bpfcc 0.35.0%2Bds

=== tests/python/CMakeLists.txt ===
# Copyright (c) PLUMgrid, Inc.
# Licensed under the Apache License, Version 2.0 (the "License")

find_program(ARPING arping)
if(ARPING STREQUAL "ARPING-NOTFOUND")
  message(WARNING "Recommended test program 'arping' not found")
endif()
find_program(NETPERF netperf)
if(NETPERF STREQUAL "NETPERF-NOTFOUND")
  message(WARNING "Recommended test program 'netperf' not found")
endif()
find_program(IPERF iperf)
if(IPERF STREQUAL "IPERF-NOTFOUND")
  find_program(IPERF3 iperf3)
  if(IPERF3 STREQUAL "IPERF3-NOTFOUND")
    message(WARNING "Recommended test program 'iperf' or 'iperf3' not found")
  endif()
endif()

add_test(NAME py_test_bpf_log WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_bpf_prog sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_bpf_log.py)
add_test(NAME py_test_stat1_c WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_stat1_c namespace ${CMAKE_CURRENT_SOURCE_DIR}/test_stat1.py test_stat1.c)
add_test(NAME py_test_xlate1_c WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_xlate1_c namespace ${CMAKE_CURRENT_SOURCE_DIR}/test_xlate1.py test_xlate1.c)
add_test(NAME py_test_call1 WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_call1_c namespace ${CMAKE_CURRENT_SOURCE_DIR}/test_call1.py test_call1.c)
add_test(NAME py_test_trace2 WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_trace2 sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_trace2.py)
add_test(NAME py_test_trace3_c WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_trace3_c sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_trace3.py test_trace3.c)
add_test(NAME py_test_trace4 WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_trace4 sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_trace4.py)
add_test(NAME py_test_trace_maxactive WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_trace_maxactive sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_trace_maxactive.py)
add_test(NAME py_test_probe_count WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_probe_count sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_probe_count.py)
add_test(NAME py_test_debuginfo WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_test_debuginfo sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_debuginfo.py)
add_test(NAME py_test_brb WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_brb_c sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_brb.py test_brb.c)
add_test(NAME py_test_brb2 WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_brb2_c sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_brb2.py test_brb2.c)
add_test(NAME py_test_clang WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_clang sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_clang.py)
add_test(NAME py_test_histogram WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_histogram sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_histogram.py)
add_test(NAME py_array WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_array sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_array.py)
add_test(NAME py_uprobes WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_uprobes sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_uprobes.py)
add_test(NAME py_uprobes_2 WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_uprobes2 sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_uprobes2.py)
add_test(NAME py_test_stackid WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_stackid sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_stackid.py)
add_test(NAME py_test_tracepoint WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_test_tracepoint sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_tracepoint.py)
add_test(NAME py_test_perf_event WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_test_perf_event sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_perf_event.py)
add_test(NAME py_test_attach_perf_event WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_test_attach_perf_event sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_attach_perf_event.py)
add_test(NAME py_test_utils WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_test_utils sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_utils.py)
add_test(NAME py_test_percpu WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_test_percpu sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_percpu.py)
add_test(NAME py_test_dump_func WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_dump_func simple ${CMAKE_CURRENT_SOURCE_DIR}/test_dump_func.py)
add_test(NAME py_test_disassembler WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_test_disassembler sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_disassembler.py)
add_test(NAME py_test_tools_smoke WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_test_tools_smoke sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_tools_smoke.py)
add_test(NAME py_test_tools_memleak WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_test_tools_memleak sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_tools_memleak.py)
if(NOT(CMAKE_SYSTEM_PROCESSOR STREQUAL "ppc64le" OR CMAKE_SYSTEM_PROCESSOR STREQUAL "ppc64"))
	add_test(NAME py_test_usdt WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
	  COMMAND ${TEST_WRAPPER} py_test_usdt sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_usdt.py)
	add_test(NAME py_test_usdt2 WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
	  COMMAND ${TEST_WRAPPER} py_test_usdt2 sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_usdt2.py)
	add_test(NAME py_test_usdt3 WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
	  COMMAND ${TEST_WRAPPER} py_test_usdt3 sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_usdt3.py)
endif()
add_test(NAME py_test_license WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_test_license sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_license.py)
add_test(NAME py_test_rlimit WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_test_rlimit sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_rlimit.py)
add_test(NAME py_test_lpm_trie WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_test_lpm_trie sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_lpm_trie.py)
add_test(NAME py_ringbuf WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_ringbuf sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_ringbuf.py)
add_test(NAME py_queuestack WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_queuestack sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_queuestack.py)
add_test(NAME py_test_map_batch_ops WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_test_map_batch_ops sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_map_batch_ops.py)
add_test(NAME py_test_map_in_map WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_test_map_in_map sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_map_in_map.py)
